﻿/*
Deployment script for Bimp

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "Bimp"
:setvar DefaultFilePrefix "Bimp"
:setvar DefaultDataPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"
:setvar DefaultLogPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
ALTER DATABASE [$(DatabaseName)]
    MODIFY FILEGROUP [PRIMARY] DEFAULT;


GO
USE [$(DatabaseName)];


GO
/*
The column [ssis].[AuditRow].[ServerExecutionID] is being dropped, data loss could occur.

The column [ssis].[AuditRow].[TaskExecutionID] is being dropped, data loss could occur.

The column [ssis].[AuditRow].[ExecutionID] on table [ssis].[AuditRow] must be added, but the column has no default value and does not allow NULL values. If the table contains data, the ALTER script will not work. To avoid this issue you must either: add a default value to the column, mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column [ssis].[AuditRow].[ExecutionInstanceGUID] on table [ssis].[AuditRow] must be added, but the column has no default value and does not allow NULL values. If the table contains data, the ALTER script will not work. To avoid this issue you must either: add a default value to the column, mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column AuditType on table [ssis].[AuditRow] must be changed from NULL to NOT NULL. If the table contains data, the ALTER script may not work. To avoid this issue, you must add values to this column for all rows or mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.
*/

IF EXISTS (select top 1 1 from [ssis].[AuditRow])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
/*
The column [ssis].[AuditRowData].[AuditRowDataID] is being dropped, data loss could occur.
*/

IF EXISTS (select top 1 1 from [ssis].[AuditRowData])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
/*
The column [ssis].[ConfigVariable].[IsEncrypted] is being dropped, data loss could occur.

The type for column VariableValue in table [ssis].[ConfigVariable] is currently  SQL_VARIANT NOT NULL but is being changed to  VARCHAR (200) NOT NULL. Data loss could occur.
*/

IF EXISTS (select top 1 1 from [ssis].[ConfigVariable])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
/*
The column [ssis].[RowCount].[ServerExecutionID] is being dropped, data loss could occur.

The column [ssis].[RowCount].[TaskExecutionID] is being dropped, data loss could occur.

The column [ssis].[RowCount].[ExecutionID] on table [ssis].[RowCount] must be added, but the column has no default value and does not allow NULL values. If the table contains data, the ALTER script will not work. To avoid this issue you must either: add a default value to the column, mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column [ssis].[RowCount].[ExecutionInstanceGUID] on table [ssis].[RowCount] must be added, but the column has no default value and does not allow NULL values. If the table contains data, the ALTER script will not work. To avoid this issue you must either: add a default value to the column, mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column ColumnName on table [ssis].[RowCount] must be changed from NULL to NOT NULL. If the table contains data, the ALTER script may not work. To avoid this issue, you must add values to this column for all rows or mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column CountType on table [ssis].[RowCount] must be changed from NULL to NOT NULL. If the table contains data, the ALTER script may not work. To avoid this issue, you must add values to this column for all rows or mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.

The column RowCount on table [ssis].[RowCount] must be changed from NULL to NOT NULL. If the table contains data, the ALTER script may not work. To avoid this issue, you must add values to this column for all rows or mark it as allowing NULL values, or enable the generation of smart-defaults as a deployment option.
*/

IF EXISTS (select top 1 1 from [ssis].[RowCount])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
PRINT N'Dropping DF__AuditRow__AuditR__1273C1CD...';


GO
ALTER TABLE [ssis].[AuditRow] DROP CONSTRAINT [DF__AuditRow__AuditR__1273C1CD];


GO
PRINT N'Dropping DF__ConfigVar__Syste__0BC6C43E...';


GO
ALTER TABLE [ssis].[ConfigVariable] DROP CONSTRAINT [DF__ConfigVar__Syste__0BC6C43E];


GO
PRINT N'Dropping DF__ConfigVar__Objec__0CBAE877...';


GO
ALTER TABLE [ssis].[ConfigVariable] DROP CONSTRAINT [DF__ConfigVar__Objec__0CBAE877];


GO
PRINT N'Dropping DF__ConfigVar__IsEnc__0DAF0CB0...';


GO
ALTER TABLE [ssis].[ConfigVariable] DROP CONSTRAINT [DF__ConfigVar__IsEnc__0DAF0CB0];


GO
PRINT N'Dropping DF__RowCount__RowCou__014935CB...';


GO
ALTER TABLE [ssis].[RowCount] DROP CONSTRAINT [DF__RowCount__RowCou__014935CB];


GO
PRINT N'Dropping [ssis].[LogAuditRow]...';


GO
DROP PROCEDURE [ssis].[LogAuditRow];


GO
PRINT N'Dropping [dbo].[AuditRowDataType]...';


GO
DROP TYPE [dbo].[AuditRowDataType];


GO
PRINT N'Creating [dbo].[AuditRowDataType]...';


GO
CREATE TYPE [dbo].[AuditRowDataType] AS TABLE (
    [RowID]       INT             NOT NULL,
    [ColumnName]  NVARCHAR (128)  NULL,
    [ColumnValue] NVARCHAR (4000) NULL);


GO
PRINT N'Starting rebuilding table [ssis].[AuditRow]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [ssis].[tmp_ms_xx_AuditRow] (
    [AuditRowDate]          DATETIME       DEFAULT (GETDATE()) NOT NULL,
    [AuditRowID]            BIGINT         IDENTITY (-9223372036854775808, 1) NOT NULL,
    [ExecutionID]           INT            NOT NULL,
    [ExecutionInstanceGUID] NCHAR (36)     NOT NULL,
    [ComponentName]         NVARCHAR (200) NOT NULL,
    [ObjectName]            NVARCHAR (200) NOT NULL,
    [AuditType]             VARCHAR (20)   NOT NULL,
    [RowCount]              INT            NULL,
    [DistinctRowCount]      INT            NULL,
    [AuditRowSchema]        XML            NOT NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_ssis_AuditRow] PRIMARY KEY CLUSTERED ([AuditRowID] DESC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [ssis].[AuditRow])
    BEGIN
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_AuditRow] ON;
        INSERT INTO [ssis].[tmp_ms_xx_AuditRow] ([AuditRowID], [AuditRowDate], [ComponentName], [ObjectName], [AuditType], [RowCount], [DistinctRowCount], [AuditRowSchema])
        SELECT   [AuditRowID],
                 [AuditRowDate],
                 [ComponentName],
                 [ObjectName],
                 [AuditType],
                 [RowCount],
                 [DistinctRowCount],
                 [AuditRowSchema]
        FROM     [ssis].[AuditRow]
        ORDER BY [AuditRowID] DESC;
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_AuditRow] OFF;
    END

DROP TABLE [ssis].[AuditRow];

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_AuditRow]', N'AuditRow';

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_constraint_PK_ssis_AuditRow]', N'PK_ssis_AuditRow', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [ssis].[AuditRowData]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [ssis].[tmp_ms_xx_AuditRowData] (
    [AuditRowID]  BIGINT          NOT NULL,
    [RowID]       INT             NOT NULL,
    [ColumnName]  NVARCHAR (128)  NOT NULL,
    [ColumnValue] NVARCHAR (4000) NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_ssis_AuditRowData] PRIMARY KEY CLUSTERED ([AuditRowID] DESC, [RowID] ASC, [ColumnName] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [ssis].[AuditRowData])
    BEGIN
        INSERT INTO [ssis].[tmp_ms_xx_AuditRowData] ([AuditRowID], [RowID], [ColumnName], [ColumnValue])
        SELECT   [AuditRowID],
                 [RowID],
                 [ColumnName],
                 [ColumnValue]
        FROM     [ssis].[AuditRowData]
        ORDER BY [AuditRowID] DESC, [RowID] ASC, [ColumnName] ASC;
    END

DROP TABLE [ssis].[AuditRowData];

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_AuditRowData]', N'AuditRowData';

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_constraint_PK_ssis_AuditRowData]', N'PK_ssis_AuditRowData', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [ssis].[ConfigVariable]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [ssis].[tmp_ms_xx_ConfigVariable] (
    [ConfigVariableID] INT           IDENTITY (1, 1) NOT NULL,
    [SystemName]       VARCHAR (100) DEFAULT ('Default') NOT NULL,
    [ObjectName]       VARCHAR (500) DEFAULT ('Default') NOT NULL,
    [VariableName]     VARCHAR (100) NOT NULL,
    [VariableValue]    VARCHAR (200) NOT NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_ssis_ConfigVariable] PRIMARY KEY CLUSTERED ([ConfigVariableID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [ssis].[ConfigVariable])
    BEGIN
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_ConfigVariable] ON;
        INSERT INTO [ssis].[tmp_ms_xx_ConfigVariable] ([ConfigVariableID], [SystemName], [ObjectName], [VariableName], [VariableValue])
        SELECT   [ConfigVariableID],
                 [SystemName],
                 [ObjectName],
                 [VariableName],
                 CAST ([VariableValue] AS VARCHAR (200))
        FROM     [ssis].[ConfigVariable]
        ORDER BY [ConfigVariableID] ASC;
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_ConfigVariable] OFF;
    END

DROP TABLE [ssis].[ConfigVariable];

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_ConfigVariable]', N'ConfigVariable';

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_constraint_PK_ssis_ConfigVariable]', N'PK_ssis_ConfigVariable', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [ssis].[RowCount]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [ssis].[tmp_ms_xx_RowCount] (
    [RowCountDate]          DATETIME       DEFAULT (GETDATE()) NOT NULL,
    [RowCountID]            BIGINT         IDENTITY (-9223372036854775808, 1) NOT NULL,
    [ExecutionID]           INT            NOT NULL,
    [ExecutionInstanceGUID] NCHAR (36)     NOT NULL,
    [ComponentName]         NVARCHAR (200) NOT NULL,
    [ObjectName]            NVARCHAR (200) NOT NULL,
    [CountType]             VARCHAR (20)   NOT NULL,
    [RowCount]              INT            NOT NULL,
    [ColumnSum]             MONEY          NULL,
    [ColumnName]            NVARCHAR (500) NOT NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_ssis_RowCount] PRIMARY KEY CLUSTERED ([RowCountID] DESC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [ssis].[RowCount])
    BEGIN
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_RowCount] ON;
        INSERT INTO [ssis].[tmp_ms_xx_RowCount] ([RowCountID], [RowCountDate], [ComponentName], [ObjectName], [CountType], [RowCount], [ColumnSum], [ColumnName])
        SELECT   [RowCountID],
                 [RowCountDate],
                 [ComponentName],
                 [ObjectName],
                 [CountType],
                 [RowCount],
                 [ColumnSum],
                 [ColumnName]
        FROM     [ssis].[RowCount]
        ORDER BY [RowCountID] DESC;
        SET IDENTITY_INSERT [ssis].[tmp_ms_xx_RowCount] OFF;
    END

DROP TABLE [ssis].[RowCount];

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_RowCount]', N'RowCount';

EXECUTE sp_rename N'[ssis].[tmp_ms_xx_constraint_PK_ssis_RowCount]', N'PK_ssis_RowCount', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creating [ssis].[Execution]...';


GO
CREATE TABLE [ssis].[Execution] (
    [ExecutionID]       INT           IDENTITY (1, 1) NOT NULL,
    [ParentExecutionID] INT           NOT NULL,
    [ServerExecutionID] BIGINT        NOT NULL,
    [PackageName]       VARCHAR (500) NOT NULL,
    [ParentSourceGUID]  NCHAR (36)    NULL,
    [ExecutionGUID]     NCHAR (36)    NOT NULL,
    [SourceGUID]        NCHAR (36)    NOT NULL,
    CONSTRAINT [PK_ssis_ServerExecution] PRIMARY KEY CLUSTERED ([ExecutionID] DESC)
);


GO
PRINT N'Creating [ssis].[Execution].[UIX_ssis_ServerExecution]...';


GO
CREATE UNIQUE NONCLUSTERED INDEX [UIX_ssis_ServerExecution]
    ON [ssis].[Execution]([ExecutionGUID] ASC, [SourceGUID] ASC);


GO
PRINT N'Creating [admin].[GetColumnListStatement]...';


GO


CREATE FUNCTION [admin].[GetColumnListStatement] 
(
	 @Catalog				NVARCHAR(128)
	,@QualifiedToTable		NVARCHAR(500)
	,@QualifiedTable		NVARCHAR(500)

) 
RETURNS NVARCHAR(MAX)
AS
BEGIN
	RETURN 
    (   
		SELECT	'USE [' + @Catalog + ']
SELECT	s.[name] AS [ColumnName]
		,sst.[name] AS [FromDataType]
		,tst.[name] AS [ToDataType]
		,CAST(t.[max_length] AS VARCHAR)
		,CAST(t.[precision] AS VARCHAR)
		,CAST(t.[scale] AS VARCHAR)
FROM [sys].[columns] s
INNER JOIN [sys].[columns] t
	ON	s.[name] = t.[name]
INNER JOIN [sys].[systypes] tst
	ON	t.[system_type_id] = tst.[xtype]
	AND	t.[user_type_id] = tst.[xusertype]
INNER JOIN [sys].[systypes] sst
	ON	s.[system_type_id] = sst.[xtype]
	AND	s.[user_type_id] = sst.[xusertype]
WHERE	s.[object_id] = OBJECT_ID(''' + @QualifiedTable + ''')
AND		t.[object_id] = OBJECT_ID(''' + @QualifiedToTable + ''')
ORDER BY s.[column_id]'	
    )
END
GO
PRINT N'Creating [admin].[GetForeignKeyStatement]...';


GO


CREATE function [admin].[GetForeignKeyStatement] 
(
	 @Catalog				NVARCHAR(128)
	,@QualifiedTable		NVARCHAR(500)
) 
RETURNS NVARCHAR(MAX)
AS
BEGIN
	RETURN 
    (   SELECT 'USE [' + @Catalog + ']
SELECT	 QUOTENAME(SCHEMA_NAME(fk.[schema_id])) + ''.'' + QUOTENAME(OBJECT_NAME(fk.[parent_object_id]))
		,QUOTENAME(fk.[name])
		,QUOTENAME(SCHEMA_NAME(so.[schema_id])) + ''.'' + QUOTENAME(so.[name])
		,QUOTENAME(sc.[name])
		,QUOTENAME(rsc.[name])
		,CASE 
			WHEN OBJECTPROPERTY(fk.[object_id], ''CnstIsUpdateCascade'') = 1 THEN '' ON UPDATE CASCADE''
			WHEN OBJECTPROPERTY(fk.[object_id], ''CnstIsDeleteCascade'') = 1 THEN '' ON DELETE CASCADE''
			ELSE ''''
		END
		,''ALTER TABLE <<ParentTable>> DROP CONSTRAINT <<ForeignKeyConstraint>>;''
		,''ALTER TABLE <<ParentTable>> WITH CHECK ADD CONSTRAINT <<ForeignKeyConstraint>> FOREIGN KEY(<<ForeignKeyColumn>>) REFERENCES <<ReferenceTable>>(<<ReferenceColumn>>)<<ConstraintCascade>>;''
FROM	[sys].[foreign_keys] fk
INNER JOIN [sys].[foreign_key_columns] fkc
	ON	fk.[object_id] = fkc.[constraint_object_id]
INNER JOIN [sys].[columns] sc
	ON	fkc.[parent_object_id] = sc.[object_id]
	AND	fkc.[parent_column_id] = sc.[column_id]
INNER JOIN [sys].[objects] so
	ON	fk.[referenced_object_id] = so.[object_id]
INNER JOIN [sys].[columns] rsc
	ON	fkc.[referenced_object_id] = rsc.[object_id]
	AND	fkc.[referenced_column_id] = rsc.[column_id]
WHERE	fk.[referenced_object_id] = OBJECT_ID(''' + @QualifiedTable + ''')'
    )
END
GO
PRINT N'Creating [ssis].[LogAuditRow]...';


GO

CREATE PROCEDURE [ssis].[LogAuditRow]
    @ExecutionID			[int],
	@ExecutionInstanceGUID	[nchar](36), 
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @AuditType				[varchar](20),
    @RowCount				[int],
    @DistinctRowCount		[int] = NULL,
    @AuditRowSchema			[xml],
	@AuditRowData			[AuditRowDataType] READONLY
AS
SET NOCOUNT ON
BEGIN TRY


	DECLARE	 @AuditRowID		BIGINT
	
    INSERT INTO [ssis].[AuditRow]
        ([ExecutionID]
		,[ExecutionInstanceGUID]
        ,[ComponentName]
        ,[ObjectName]
        ,[AuditType]
        ,[RowCount]
        ,[DistinctRowCount]
        ,[AuditRowSchema])
    VALUES
        (@ExecutionID
		,@ExecutionInstanceGUID
        ,@ComponentName
        ,@ObjectName
        ,@AuditType
        ,@RowCount
        ,@DistinctRowCount
        ,@AuditRowSchema);

	SELECT @AuditRowID = SCOPE_IDENTITY();

	INSERT INTO [ssis].[AuditRowData]
			([AuditRowID]
			,[RowID]
			,[ColumnName]
			,[ColumnValue])
     SELECT	 @AuditRowID	
			,[RowID]
			,[ColumnName]
			,[ColumnValue]
	FROM	@AuditRowData

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Altering [ssis].[LogRowCount]...';


GO
ALTER PROCEDURE [ssis].[LogRowCount](
    @ExecutionID			[int],
	@ExecutionInstanceGUID	[nchar](36), 
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @CountType				[varchar](20),
    @RowCount				[int],
	@ColumnSum				[money],
	@ColumnName				[varchar](200)
) 
AS
BEGIN TRY
	
    INSERT INTO [ssis].[RowCount]
        ([ExecutionID]
		,[ExecutionInstanceGUID]
        ,[ComponentName]
        ,[ObjectName]
        ,[CountType]
        ,[RowCount]
		,[ColumnSum]
		,[ColumnName])
    VALUES
        (@ExecutionID
		,@ExecutionInstanceGUID
        ,@ComponentName
        ,@ObjectName
        ,@CountType
        ,@RowCount
		,@ColumnSum
		,@ColumnName);

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Altering [admin].[TableCopy]...';


GO


ALTER PROCEDURE [admin].[TableCopy]
	 @Catalog				NVARCHAR(128)
	,@Schema				NVARCHAR(128)
	,@Table					NVARCHAR(128)
	,@ToSchema				NVARCHAR(128) = NULL	
	,@ToTable				NVARCHAR(128) = NULL
	,@DropToTable			BIT = 0
	,@TruncToTable			BIT = 1
AS
SET NOCOUNT ON
BEGIN
	DECLARE  @QualifiedToTable		NVARCHAR(500)
			,@QualifiedTable		NVARCHAR(500)
			,@SqlColumnList			VARCHAR(MAX)
			,@SqlColumnsSelect		VARCHAR(MAX)
			,@SqlExec				NVARCHAR(MAX)
			,@NL					CHAR(2)
			,@RC					INT

	SET		@NL = CHAR(13) + CHAR(10)
	SET		@ToSchema = ISNULL(@ToSchema, 'copy')
	SET		@ToTable = ISNULL(@ToTable, @Table)
	SELECT	@QualifiedToTable = '[' + @Catalog + '].[' + @ToSchema + '].[' + @ToTable + ']'
	SELECT	@QualifiedTable = '[' + @Catalog + '].[' + @Schema + '].[' + @Table + ']'
	IF OBJECT_ID(@QualifiedTable) IS NOT NULL
	BEGIN
		BEGIN TRY
			BEGIN TRANSACTION;			

			IF OBJECT_ID(@QualifiedToTable) IS NOT NULL AND (@TruncToTable = 1)
			BEGIN 
				EXEC ('TRUNCATE TABLE ' + @QualifiedToTable)
			END
			ELSE IF OBJECT_ID(@QualifiedToTable) IS NOT NULL AND (@DropToTable = 1)
			BEGIN 
				EXEC ('DROP TABLE ' + @QualifiedToTable)
			END

			-- Create Default ToTable if it is missing
			IF OBJECT_ID(@QualifiedToTable) IS NULL
			BEGIN
				SET		@SqlExec = 'SELECT * INTO ' + @QualifiedToTable + ' FROM ' + @QualifiedTable + ' WHERE 1=2'
				EXEC	(@SqlExec)		
			END
				
			DECLARE  @ColumnName		NVARCHAR(128)
					,@FromDataType		NVARCHAR(128)
					,@ToDataType		NVARCHAR(128)
					,@ToMaxLength		VARCHAR(10)
					,@ToPrecision		VARCHAR(10)
					,@ToScale			VARCHAR(10)
				
			-- Get the column info
			DECLARE @tblColumns TABLE ( 
					[ColumnName]		NVARCHAR(128),
					[FromDataType]		NVARCHAR(128),
					[ToDataType]		NVARCHAR(128),
					[ToMaxLength]		VARCHAR(10),
					[ToPrecision]		VARCHAR(10),
					[ToScale]			VARCHAR(10))
				
			SET		@SqlExec = [admin].[GetColumnListStatement](@Catalog, @QualifiedToTable, @QualifiedTable)
			--PRINT	@SqlExec
			INSERT INTO @tblColumns EXEC (@SqlExec)						

			-- Create Cursor for all common columns
			DECLARE crsColumns CURSOR FOR 
			SELECT	 [ColumnName]
					,[FromDataType]
					,[ToDataType]
					,[ToMaxLength]
					,[ToPrecision]
					,[ToScale]
			FROM	@tblColumns	

			OPEN crsColumns
			FETCH NEXT FROM crsColumns INTO @ColumnName, @FromDataType, @ToDataType, @ToMaxLength, @ToPrecision, @ToScale

			SET		@SqlColumnList = ''
			SET		@SqlColumnsSelect = ''
			WHILE @@FETCH_STATUS = 0
			BEGIN
				SET		@SqlColumnList = @SqlColumnList + ',' + @ColumnName	
				SET		@SqlColumnsSelect = @SqlColumnsSelect + ',' + 
						(SELECT CASE @FromDataType
							WHEN @ToDataType THEN @ColumnName
							ELSE		
								'CAST(' + @ColumnName + ' AS ' +
								CASE @ToDataType
									WHEN 'money' THEN 'money(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'decimal' THEN 'decimal(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'numeric' THEN 'numeric(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'smallmoney' THEN 'smallmoney(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'varbinary' THEN 'varbinary(' + @ToMaxLength + ')'
									WHEN 'varchar' THEN 'varchar(' + @ToMaxLength + ')'
									WHEN 'binary' THEN 'binary(' + @ToMaxLength + ')'
									WHEN 'char' THEN 'char(' + @ToMaxLength + ')'
									WHEN 'nvarchar' THEN 'nvarchar(' + @ToMaxLength + ')'
									WHEN 'nchar' THEN 'nchar(' + @ToMaxLength + ')'
									ELSE @ToDataType
								END + ') AS ' + @ColumnName
							END)
				FETCH NEXT FROM crsColumns INTO @ColumnName, @FromDataType, @ToDataType, @ToMaxLength, @ToPrecision, @ToScale
			END
			CLOSE crsColumns
			DEALLOCATE crsColumns

			-- Trim the leading commas
			SET 	@SqlColumnList = RIGHT(@SqlColumnList, LEN(@SqlColumnList) - 1)
			SET		@SqlColumnsSelect = RIGHT(@SqlColumnsSelect, LEN(@SqlColumnsSelect) - 1)
			SET		@SqlExec = 'USE [' + @Catalog + '] SELECT OBJECTPROPERTY(OBJECT_ID(N''' + @QualifiedToTable + '''), N''TableHasIdentity'')'
			
			DECLARE @HasIdentity INT
			DECLARE @tblHasIdentity TABLE ([HasIdentity]	INT)
							
			INSERT INTO @tblHasIdentity
			EXEC	(@SqlExec)
					
			SELECT	@HasIdentity = ISNULL([HasIdentity], 0)
			FROM	@tblHasIdentity
					
			-- Build the copy sql
			SET		@SqlExec = 'INSERT INTO ' + @QualifiedToTable + '(' + @SqlColumnList + ') ' +  @NL 
					+ 'SELECT ' + @SqlColumnsSelect + @NL
					+ 'FROM ' + @QualifiedTable

			-- If identity append the SET IDENTITY_INSERT commands
			IF @HasIdentity = 1
					SET		@SqlExec = 'SET IDENTITY_INSERT ' + @QualifiedToTable + ' ON ;' +  @NL 
							+ ' ' +  @SqlExec + '; ' +  @NL + 'SET IDENTITY_INSERT ' + @QualifiedToTable + ' OFF'

			EXEC	(@SqlExec)

			COMMIT TRANSACTION;			

		END TRY

		BEGIN CATCH
			SELECT	ERROR_NUMBER()	AS [ErrorNumber],
					ERROR_MESSAGE() AS [ErrorMessage];

			-- Test if the transaction is uncommittable.
			IF (XACT_STATE()) = -1
			BEGIN
				PRINT	N'The transaction is in an uncommittable state. ' +
						'Rolling back transaction.'
				ROLLBACK TRANSACTION;
			END;

			-- Test if the transaction is active and valid.
			IF (XACT_STATE()) = 1
			BEGIN
				PRINT	N'The transaction is committable. ' +
						'Committing transaction.'
				COMMIT TRANSACTION;   
			END;
			RETURN	ERROR_NUMBER();
		END CATCH;
	END
	RETURN 0
END
GO
PRINT N'Altering [admin].[TableDeploy]...';


GO


ALTER PROCEDURE [admin].[TableDeploy]
	 @Catalog				NVARCHAR(128)
	,@Schema				NVARCHAR(128)
	,@Table					NVARCHAR(128)
	,@ToSchema				NVARCHAR(128) = NULL	
	,@ToTable				NVARCHAR(128) = NULL
	,@BackupSchema			NVARCHAR(128) = NULL
AS

SET NOCOUNT ON
DECLARE  @QualifiedToTable	NVARCHAR(512)
		,@QualifiedTable	NVARCHAR(512)
		,@BackupTable		NVARCHAR(512)
		,@SqlExec			NVARCHAR(MAX)
		,@NL				CHAR(2)			= CHAR(13) + CHAR(10)
		,@RC				INT

SET		@ToSchema = ISNULL(@ToSchema, 'copy')
SET		@ToTable = ISNULL(@ToTable, @Table)
SET		@QualifiedToTable = '[' + @Catalog + '].[' + @ToSchema + '].[' + @ToTable + ']'
SET		@QualifiedTable = '[' + @Catalog + '].[' + @Schema + '].[' + @Table + ']'
SET		@BackupTable = '[' + @Catalog + '].[backup].[' + @Table + ']'

SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''backup'') EXEC (''CREATE SCHEMA [backup] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)
SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''copy'') EXEC (''CREATE SCHEMA [copy] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)
SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''' + @Schema + ''') EXEC (''CREATE SCHEMA [' + @Schema + '] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)

DECLARE @tblConstraints	TABLE(
		[ParentTable]			[nvarchar](512),
		[ForeignKeyConstraint]	[nvarchar](512),
		[ReferenceTable]		[nvarchar](512),
		[ForeignKeyColumn]		[nvarchar](512),
		[ReferenceColumn]		[nvarchar](512),
		[ConstraintCascade]		[nvarchar](128),
		[DropPattern]			[nvarchar](256),
		[CreatePattern]			[nvarchar](256))

IF OBJECT_ID(@BackupTable) IS NOT NULL
BEGIN 
	EXEC ('DROP TABLE ' + @BackupTable)
END

IF OBJECT_ID(@QualifiedTable) IS NULL
BEGIN
	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
			+ 'ALTER SCHEMA [' + @Schema + '] TRANSFER [' + @ToSchema + '].[' + @ToTable + ']'
	EXEC (@SqlExec)
END
ELSE
BEGIN
	EXEC @RC = [admin].[TableCompare] @Catalog, @Schema, @Table, @ToSchema, @ToTable

	IF ISNULL(@RC, -1) = -1		-- Table changes detected
	BEGIN
		EXEC @RC = [admin].[TableCopy] @Catalog, @Schema, @Table, @ToSchema, @ToTable

		SET	@SqlExec = [admin].[GetForeignKeyStatement](@Catalog, @QualifiedTable)
		INSERT INTO @tblConstraints EXEC (@SqlExec)

		BEGIN TRY
			BEGIN TRANSACTION;	
					
			IF OBJECT_ID(@QualifiedTable) IS NOT NULL
			BEGIN
				DECLARE crsDropConstraints CURSOR FOR
				SELECT	'USE [' + @Catalog + ']' + @NL + REPLACE(REPLACE([DropPattern], '<<ParentTable>>', [ParentTable]), '<<ForeignKeyConstraint>>', [ForeignKeyConstraint])
				FROM	@tblConstraints

				OPEN crsDropConstraints
				FETCH NEXT FROM crsDropConstraints INTO @SqlExec
				WHILE @@FETCH_STATUS = 0
				BEGIN
					EXEC (@SqlExec)
					FETCH NEXT FROM crsDropConstraints INTO @SqlExec
				END
				CLOSE crsDropConstraints
				DEALLOCATE crsDropConstraints
				
				-- ALTER SCHEMA [backup]				
				SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
						+ 'ALTER SCHEMA [backup] TRANSFER [' + @Schema + '].[' + @Table + ']'
				EXEC (@SqlExec)
			END		
														
			-- ALTER SCHEMA @Schema
			SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
					+ 'ALTER SCHEMA [' + @Schema + '] TRANSFER [' + @ToSchema + '].[' + @ToTable + ']'
			EXEC (@SqlExec)
			
			DECLARE crsAddConstraints CURSOR FOR
			SELECT	'USE [' + @Catalog + ']' + @NL +
					REPLACE(
						REPLACE(
							REPLACE(
								REPLACE(
									REPLACE(
										REPLACE([CreatePattern], '<<ParentTable>>', [ParentTable])
									, '<<ForeignKeyConstraint>>', [ForeignKeyConstraint])
								,'<<ForeignKeyColumn>>', [ForeignKeyColumn])
							,'<<ReferenceTable>>', [ReferenceTable])
						,'<<ReferenceColumn>>', [ReferenceColumn])
					,'<<ConstraintCascade>>', [ConstraintCascade])
			FROM	@tblConstraints

			OPEN crsAddConstraints
			FETCH NEXT FROM crsAddConstraints INTO @SqlExec
			WHILE @@FETCH_STATUS = 0
			BEGIN
				EXEC (@SqlExec)
				FETCH NEXT FROM crsAddConstraints INTO @SqlExec
			END
			CLOSE crsAddConstraints
			DEALLOCATE crsAddConstraints

			COMMIT TRANSACTION;

			IF OBJECT_ID(@BackupTable) IS NOT NULL
			BEGIN 
				SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
						+ 'DROP TABLE [backup].[' + @Table + ']'
				EXEC (@SqlExec)			
			END
		END TRY
				
		BEGIN CATCH
			SELECT	ERROR_NUMBER()	AS [ErrorNumber],
					ERROR_MESSAGE() AS [ErrorMessage];

			-- Test if the transaction is uncommittable.
			IF (XACT_STATE()) = -1
			BEGIN
				PRINT	N'The transaction is in an uncommittable state. ' +
						'Rolling back transaction.'
				ROLLBACK TRANSACTION;
			END;

			-- Test if the transaction is active and valid.
			IF (XACT_STATE()) = 1
			BEGIN
				PRINT	N'The transaction is committable. ' +
						'Committing transaction.'
				COMMIT TRANSACTION;   
			END;
			RETURN	ERROR_NUMBER();
		END CATCH;

		RETURN 0
	END
--	ELSE IF ISNULL(@RC, -1) = -2		-- PRIMARY KEY CHANGES DETECTED
--	BEGIN
--
--	END
	ELSE
	BEGIN
		IF OBJECT_ID(@QualifiedToTable) IS NOT NULL
		BEGIN 
			SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
					+ 'DROP TABLE ' + @QualifiedToTable
			EXEC (@SqlExec)			
		END
	END
END
GO
PRINT N'Creating [ssis].[LogExecution]...';


GO
CREATE PROCEDURE [ssis].[LogExecution](
	@ExecutionGUID			[nvarchar](40),
	@SourceGUID				[nvarchar](40),
	@PackageName			[varchar](500),
	@ParentSourceGUID		[nvarchar](40),
	@ParentExecutionID		[int],
	@ServerExecutionID		[bigint],
	@ExecutionID			[int]         = NULL OUTPUT
) 
AS 
CREATE TABLE #Object ([ObjectID] [int]);


SELECT  @ExecutionID = MAX([ExecutionID])
FROM    [ssis].[Execution]
WHERE   [SourceGUID] = REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
AND		[ExecutionGUID] = REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
AND		[ParentExecutionID] = ISNULL(@ParentExecutionID, -1);

IF @ExecutionID IS NULL
BEGIN
	INSERT INTO [ssis].[Execution]
			([ParentExecutionID]
			,[ExecutionGUID]
			,[SourceGUID]
			,[PackageName]
			,[ParentSourceGUID]
			,[ServerExecutionID])
	VALUES	(ISNULL(@ParentExecutionID, -1)
			,REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
			,REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
			,ISNULL(@PackageName, 'Not Sepcified')
			,ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '')
			,@ServerExecutionID);

	SELECT  @ExecutionID = SCOPE_IDENTITY();
END

IF ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '') <> ''
BEGIN
	UPDATE	[ssis].[Execution]
	SET		[ParentSourceGUID] = REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', '')
	WHERE	[ServerExecutionID] = @ServerExecutionID
END
GO
PRINT N'Update complete.';


GO
