﻿/*
Deployment script for Bimp

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "Bimp"
:setvar DefaultFilePrefix "Bimp"
:setvar DefaultDataPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"
:setvar DefaultLogPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
PRINT N'Dropping [dbo].[AuditRowDataType]...';


GO
DROP TYPE [dbo].[AuditRowDataType];


GO
PRINT N'Creating [dbo].[AuditRowDataType]...';


GO
CREATE TYPE [dbo].[AuditRowDataType] AS TABLE (
    [RowID]       INT             NOT NULL,
    [ColumnName]  NVARCHAR (128)  NULL,
    [ColumnValue] NVARCHAR (4000) NULL);


GO
PRINT N'Creating [ssis].[AuditRow]...';


GO
CREATE TABLE [ssis].[AuditRow] (
    [AuditRowDate]          DATETIME       NOT NULL,
    [AuditRowID]            BIGINT         IDENTITY (-9223372036854775808, 1) NOT NULL,
    [ExecutionID]           INT            NOT NULL,
    [ExecutionInstanceGUID] NCHAR (36)     NOT NULL,
    [ComponentName]         NVARCHAR (200) NOT NULL,
    [ObjectName]            NVARCHAR (200) NOT NULL,
    [AuditType]             VARCHAR (20)   NOT NULL,
    [RowCount]              INT            NULL,
    [DistinctRowCount]      INT            NULL,
    [AuditRowSchema]        XML            NOT NULL,
    CONSTRAINT [PK_ssis_AuditRow] PRIMARY KEY CLUSTERED ([AuditRowID] DESC)
);


GO
PRINT N'Creating [ssis].[AuditRowData]...';


GO
CREATE TABLE [ssis].[AuditRowData] (
    [AuditRowID]  BIGINT          NOT NULL,
    [RowID]       INT             NOT NULL,
    [ColumnName]  NVARCHAR (128)  NOT NULL,
    [ColumnValue] NVARCHAR (4000) NULL,
    CONSTRAINT [PK_ssis_AuditRowData] PRIMARY KEY CLUSTERED ([AuditRowID] DESC, [RowID] ASC, [ColumnName] ASC)
);


GO
PRINT N'Creating [ssis].[ConfigVariable]...';


GO
CREATE TABLE [ssis].[ConfigVariable] (
    [ConfigVariableID] INT           IDENTITY (1, 1) NOT NULL,
    [SystemName]       VARCHAR (100) NOT NULL,
    [ObjectName]       VARCHAR (500) NOT NULL,
    [VariableName]     VARCHAR (100) NOT NULL,
    [VariableValue]    VARCHAR (200) NOT NULL,
    CONSTRAINT [PK_ssis_ConfigVariable] PRIMARY KEY CLUSTERED ([ConfigVariableID] ASC)
);


GO
PRINT N'Creating [ssis].[Execution]...';


GO
CREATE TABLE [ssis].[Execution] (
    [ExecutionID]       INT           IDENTITY (1, 1) NOT NULL,
    [ParentExecutionID] INT           NOT NULL,
    [ServerExecutionID] BIGINT        NOT NULL,
    [PackageName]       VARCHAR (500) NOT NULL,
    [ParentSourceGUID]  NCHAR (36)    NULL,
    [ExecutionGUID]     NCHAR (36)    NOT NULL,
    [SourceGUID]        NCHAR (36)    NOT NULL,
    CONSTRAINT [PK_ssis_ServerExecution] PRIMARY KEY CLUSTERED ([ExecutionID] DESC)
);


GO
PRINT N'Creating [ssis].[Execution].[UIX_ssis_ServerExecution]...';


GO
CREATE UNIQUE NONCLUSTERED INDEX [UIX_ssis_ServerExecution]
    ON [ssis].[Execution]([ExecutionGUID] ASC, [SourceGUID] ASC);


GO
PRINT N'Creating [ssis].[RowCount]...';


GO
CREATE TABLE [ssis].[RowCount] (
    [RowCountDate]          DATETIME       NOT NULL,
    [RowCountID]            BIGINT         IDENTITY (-9223372036854775808, 1) NOT NULL,
    [ExecutionID]           INT            NOT NULL,
    [ExecutionInstanceGUID] NCHAR (36)     NOT NULL,
    [ComponentName]         NVARCHAR (200) NOT NULL,
    [ObjectName]            NVARCHAR (200) NOT NULL,
    [CountType]             VARCHAR (20)   NOT NULL,
    [RowCount]              INT            NOT NULL,
    [ColumnSum]             MONEY          NULL,
    [ColumnName]            NVARCHAR (500) NOT NULL,
    CONSTRAINT [PK_ssis_RowCount] PRIMARY KEY CLUSTERED ([RowCountID] DESC)
);


GO
PRINT N'Creating Default Constraint on [ssis].[AuditRow]....';


GO
ALTER TABLE [ssis].[AuditRow]
    ADD DEFAULT (GETDATE()) FOR [AuditRowDate];


GO
PRINT N'Creating Default Constraint on [ssis].[ConfigVariable]....';


GO
ALTER TABLE [ssis].[ConfigVariable]
    ADD DEFAULT ('Default') FOR [SystemName];


GO
PRINT N'Creating Default Constraint on [ssis].[ConfigVariable]....';


GO
ALTER TABLE [ssis].[ConfigVariable]
    ADD DEFAULT ('Default') FOR [ObjectName];


GO
PRINT N'Creating Default Constraint on [ssis].[RowCount]....';


GO
ALTER TABLE [ssis].[RowCount]
    ADD DEFAULT (GETDATE()) FOR [RowCountDate];


GO
PRINT N'Creating [admin].[GetColumnListStatement]...';


GO


CREATE FUNCTION [admin].[GetColumnListStatement] 
(
	 @Catalog				NVARCHAR(128)
	,@QualifiedToTable		NVARCHAR(500)
	,@QualifiedTable		NVARCHAR(500)

) 
RETURNS NVARCHAR(MAX)
AS
BEGIN
	RETURN 
    (   
		SELECT	'USE [' + @Catalog + ']
SELECT	s.[name] AS [ColumnName]
		,sst.[name] AS [FromDataType]
		,tst.[name] AS [ToDataType]
		,CAST(t.[max_length] AS VARCHAR)
		,CAST(t.[precision] AS VARCHAR)
		,CAST(t.[scale] AS VARCHAR)
FROM [sys].[columns] s
INNER JOIN [sys].[columns] t
	ON	s.[name] = t.[name]
INNER JOIN [sys].[systypes] tst
	ON	t.[system_type_id] = tst.[xtype]
	AND	t.[user_type_id] = tst.[xusertype]
INNER JOIN [sys].[systypes] sst
	ON	s.[system_type_id] = sst.[xtype]
	AND	s.[user_type_id] = sst.[xusertype]
WHERE	s.[object_id] = OBJECT_ID(''' + @QualifiedTable + ''')
AND		t.[object_id] = OBJECT_ID(''' + @QualifiedToTable + ''')
ORDER BY s.[column_id]'	
    )
END
GO
PRINT N'Creating [admin].[GetForeignKeyStatement]...';


GO


CREATE function [admin].[GetForeignKeyStatement] 
(
	 @Catalog				NVARCHAR(128)
	,@QualifiedTable		NVARCHAR(500)
) 
RETURNS NVARCHAR(MAX)
AS
BEGIN
	RETURN 
    (   SELECT 'USE [' + @Catalog + ']
SELECT	 QUOTENAME(SCHEMA_NAME(fk.[schema_id])) + ''.'' + QUOTENAME(OBJECT_NAME(fk.[parent_object_id]))
		,QUOTENAME(fk.[name])
		,QUOTENAME(SCHEMA_NAME(so.[schema_id])) + ''.'' + QUOTENAME(so.[name])
		,QUOTENAME(sc.[name])
		,QUOTENAME(rsc.[name])
		,CASE 
			WHEN OBJECTPROPERTY(fk.[object_id], ''CnstIsUpdateCascade'') = 1 THEN '' ON UPDATE CASCADE''
			WHEN OBJECTPROPERTY(fk.[object_id], ''CnstIsDeleteCascade'') = 1 THEN '' ON DELETE CASCADE''
			ELSE ''''
		END
		,''ALTER TABLE <<ParentTable>> DROP CONSTRAINT <<ForeignKeyConstraint>>;''
		,''ALTER TABLE <<ParentTable>> WITH CHECK ADD CONSTRAINT <<ForeignKeyConstraint>> FOREIGN KEY(<<ForeignKeyColumn>>) REFERENCES <<ReferenceTable>>(<<ReferenceColumn>>)<<ConstraintCascade>>;''
FROM	[sys].[foreign_keys] fk
INNER JOIN [sys].[foreign_key_columns] fkc
	ON	fk.[object_id] = fkc.[constraint_object_id]
INNER JOIN [sys].[columns] sc
	ON	fkc.[parent_object_id] = sc.[object_id]
	AND	fkc.[parent_column_id] = sc.[column_id]
INNER JOIN [sys].[objects] so
	ON	fk.[referenced_object_id] = so.[object_id]
INNER JOIN [sys].[columns] rsc
	ON	fkc.[referenced_object_id] = rsc.[object_id]
	AND	fkc.[referenced_column_id] = rsc.[column_id]
WHERE	fk.[referenced_object_id] = OBJECT_ID(''' + @QualifiedTable + ''')'
    )
END
GO
PRINT N'Creating [admin].[TableCompare]...';


GO


CREATE PROCEDURE [admin].[TableCompare]
	 @Catalog			NVARCHAR(128)
	,@Schema			NVARCHAR(128)
	,@Table				NVARCHAR(128)
	,@ToSchema			NVARCHAR(128)
	,@ToTable			NVARCHAR(128)
AS
SET NOCOUNT ON
DECLARE  @DiffCount		INT
		,@SqlExec		NVARCHAR(MAX)
		,@NL			CHAR(2)			= CHAR(13) + CHAR(10)

CREATE TABLE #SourceColumns(
	[TABLE_CATALOG]				[nvarchar](128),
	[TABLE_SCHEMA]				[nvarchar](128),
	[TABLE_NAME]				[nvarchar](128),
	[COLUMN_NAME]				[nvarchar](128),
	[ORDINAL_POSITION]			[int],
	[COLUMN_DEFAULT]			[nvarchar](4000),
	[IS_NULLABLE]				[varchar](3),
	[DATA_TYPE]					[nvarchar](128),
	[CHARACTER_MAXIMUM_LENGTH]	[int],
	[CHARACTER_OCTET_LENGTH]	[int],
	[NUMERIC_PRECISION]			[tinyint],
	[NUMERIC_PRECISION_RADIX]	[smallint],
	[NUMERIC_SCALE]				[int],
	[DATETIME_PRECISION]		[smallint],
	[CHARACTER_SET_CATALOG]		[nvarchar](128),
	[CHARACTER_SET_SCHEMA]		[nvarchar](128),
	[CHARACTER_SET_NAME]		[nvarchar](128),
	[COLLATION_CATALOG]			[nvarchar](128),
	[COLLATION_SCHEMA]			[nvarchar](128),
	[COLLATION_NAME]			[nvarchar](128),
	[DOMAIN_CATALOG]			[nvarchar](128),
	[DOMAIN_SCHEMA]				[nvarchar](128),
	[DOMAIN_NAME]				[nvarchar](128),
	[IsIdentity]				[tinyint])

CREATE TABLE #CurrentColumns(
	[TABLE_CATALOG]				[nvarchar](128),
	[TABLE_SCHEMA]				[nvarchar](128),
	[TABLE_NAME]				[nvarchar](128),
	[COLUMN_NAME]				[nvarchar](128),
	[ORDINAL_POSITION]			[int],
	[COLUMN_DEFAULT]			[nvarchar](4000),
	[IS_NULLABLE]				[varchar](3),
	[DATA_TYPE]					[nvarchar](128),
	[CHARACTER_MAXIMUM_LENGTH]	[int],
	[CHARACTER_OCTET_LENGTH]	[int],
	[NUMERIC_PRECISION]			[tinyint],
	[NUMERIC_PRECISION_RADIX]	[smallint],
	[NUMERIC_SCALE]				[int],
	[DATETIME_PRECISION]		[smallint],
	[CHARACTER_SET_CATALOG]		[nvarchar](128),
	[CHARACTER_SET_SCHEMA]		[nvarchar](128),
	[CHARACTER_SET_NAME]		[nvarchar](128),
	[COLLATION_CATALOG]			[nvarchar](128),
	[COLLATION_SCHEMA]			[nvarchar](128),
	[COLLATION_NAME]			[nvarchar](128),
	[DOMAIN_CATALOG]			[nvarchar](128),
	[DOMAIN_SCHEMA]				[nvarchar](128),
	[DOMAIN_NAME]				[nvarchar](128),
	[IsIdentity]				[tinyint])

SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
		+ 'SELECT	* ' + @NL
		+ '		,COLUMNPROPERTY(OBJECT_ID(''[' + @Schema + '].[' + @Table + ']''), [COLUMN_NAME], ''IsIdentity'') AS [IsIdentity]' + @NL
		+ 'FROM	[INFORMATION_SCHEMA].[COLUMNS]' + @NL
		+ 'WHERE	[TABLE_CATALOG] = ''' + @Catalog + '''' + @NL
		+ 'AND		[TABLE_SCHEMA] = ''' + @Schema + '''' + @NL
		+ 'AND		[TABLE_NAME] = ''' + @Table + ''''


INSERT #CurrentColumns
EXEC (@SqlExec)

SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
		+ 'SELECT	* ' + @NL
		+ '		,COLUMNPROPERTY(OBJECT_ID(''[' + @ToSchema + '].[' + @ToTable + ']''), [COLUMN_NAME], ''IsIdentity'') AS [IsIdentity]' + @NL
		+ 'FROM	[INFORMATION_SCHEMA].[COLUMNS]' + @NL
		+ 'WHERE	[TABLE_CATALOG] = ''' + @Catalog + '''' + @NL
		+ 'AND		[TABLE_SCHEMA] = ''' + @ToSchema + '''' + @NL
		+ 'AND		[TABLE_NAME] = ''' + @ToTable + ''''

INSERT #SourceColumns
EXEC (@SqlExec)

SELECT	@DiffCount = COUNT(*)
FROM	#CurrentColumns o
FULL OUTER JOIN #SourceColumns n
	ON	ISNULL(o.[COLUMN_NAME], '') = ISNULL(n.[COLUMN_NAME], '')
WHERE	NOT (	ISNULL(o.[ORDINAL_POSITION], 0) = ISNULL(n.[ORDINAL_POSITION], 0)
		AND	ISNULL(o.[COLUMN_DEFAULT], '') = ISNULL(n.[COLUMN_DEFAULT], '')
		AND	ISNULL(o.[IS_NULLABLE], '') = ISNULL(n.[IS_NULLABLE], '')
		AND	ISNULL(o.[DATA_TYPE], '') = ISNULL(n.[DATA_TYPE], '')
		AND	ISNULL(o.[CHARACTER_MAXIMUM_LENGTH], 0) = ISNULL(n.[CHARACTER_MAXIMUM_LENGTH], 0)
		AND	ISNULL(o.[CHARACTER_OCTET_LENGTH], 0) = ISNULL(n.[CHARACTER_OCTET_LENGTH], 0)
		AND	ISNULL(o.[NUMERIC_PRECISION], 0) = ISNULL(n.[NUMERIC_PRECISION], 0)
		AND	ISNULL(o.[NUMERIC_PRECISION_RADIX], 0) = ISNULL(n.[NUMERIC_PRECISION_RADIX], 0)
		AND	ISNULL(o.[NUMERIC_SCALE], 0) = ISNULL(n.[NUMERIC_SCALE], 0)
		AND	ISNULL(o.[DATETIME_PRECISION], 0) = ISNULL(n.[DATETIME_PRECISION], 0)
		AND	ISNULL(o.[CHARACTER_SET_CATALOG], '') = ISNULL(n.[CHARACTER_SET_CATALOG], '')
		AND	ISNULL(o.[CHARACTER_SET_SCHEMA], '') = ISNULL(n.[CHARACTER_SET_SCHEMA], '')
		AND	ISNULL(o.[CHARACTER_SET_NAME], '') = ISNULL(n.[CHARACTER_SET_NAME], '')
		AND	ISNULL(o.[COLLATION_CATALOG], '') = ISNULL(n.[COLLATION_CATALOG], '')
		AND	ISNULL(o.[COLLATION_SCHEMA], '') = ISNULL(n.[COLLATION_SCHEMA], '')
		AND	ISNULL(o.[COLLATION_NAME], '') = ISNULL(n.[COLLATION_NAME], '')
		AND	ISNULL(o.[DOMAIN_CATALOG], '') = ISNULL(n.[DOMAIN_CATALOG], '')
		AND	ISNULL(o.[DOMAIN_SCHEMA], '') = ISNULL(n.[DOMAIN_SCHEMA], '')
		AND	ISNULL(o.[DOMAIN_NAME], '') = ISNULL(n.[DOMAIN_NAME], '')
		AND	ISNULL(o.[IsIdentity], 0) = ISNULL(n.[IsIdentity], 0))

IF @DiffCount > 0 
BEGIN
	RETURN -1
END
ELSE
BEGIN
	DELETE FROM #CurrentColumns
	DELETE FROM #SourceColumns

	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
			+ 'SELECT	c.[TABLE_CATALOG],c.[TABLE_SCHEMA],c.[TABLE_NAME],c.[COLUMN_NAME],c.[ORDINAL_POSITION]' + @NL
			+ 'FROM	[INFORMATION_SCHEMA].[TABLE_CONSTRAINTS] p' + @NL
			+ 'INNER JOIN [INFORMATION_SCHEMA].[KEY_COLUMN_USAGE] c' + @NL
			+ '	ON	c.[TABLE_SCHEMA] = p.[TABLE_SCHEMA]' + @NL
			+ '	AND	c.[TABLE_NAME] = p.[TABLE_NAME]' + @NL
			+ '	AND	c.[CONSTRAINT_NAME] = p.[CONSTRAINT_NAME]' + @NL
			+ 'WHERE	p.[CONSTRAINT_TYPE] = ''PRIMARY KEY''' + @NL
			+ 'AND		p.[TABLE_CATALOG] = ''' + @Catalog + '''' + @NL
			+ 'AND		p.[TABLE_SCHEMA] = ''' + @Schema + '''' + @NL
			+ 'AND		p.[TABLE_NAME] = ''' + @Table + ''''

	INSERT INTO #CurrentColumns([TABLE_CATALOG],[TABLE_SCHEMA],[TABLE_NAME],[COLUMN_NAME],[ORDINAL_POSITION])
	EXEC (@SqlExec)


	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
			+ 'SELECT	c.[TABLE_CATALOG],c.[TABLE_SCHEMA],c.[TABLE_NAME],c.[COLUMN_NAME],c.[ORDINAL_POSITION]' + @NL
			+ 'FROM	[INFORMATION_SCHEMA].[TABLE_CONSTRAINTS] p' + @NL
			+ 'INNER JOIN [INFORMATION_SCHEMA].[KEY_COLUMN_USAGE] c' + @NL
			+ '	ON	c.[TABLE_SCHEMA] = p.[TABLE_SCHEMA]' + @NL
			+ '	AND	c.[TABLE_NAME] = p.[TABLE_NAME]' + @NL
			+ '	AND	c.[CONSTRAINT_NAME] = p.[CONSTRAINT_NAME]' + @NL
			+ 'WHERE	p.[CONSTRAINT_TYPE] = ''PRIMARY KEY''' + @NL
			+ 'AND		p.[TABLE_CATALOG] = ''' + @Catalog + '''' + @NL
			+ 'AND		p.[TABLE_SCHEMA] = ''' + @ToSchema + '''' + @NL
			+ 'AND		p.[TABLE_NAME] = ''' + @ToTable + ''''

	INSERT INTO #SourceColumns([TABLE_CATALOG],[TABLE_SCHEMA],[TABLE_NAME],[COLUMN_NAME],[ORDINAL_POSITION])
	EXEC (@SqlExec)

	SELECT	@DiffCount = COUNT(*)
	FROM	#CurrentColumns o
	FULL OUTER JOIN #SourceColumns n
		ON	ISNULL(o.[COLUMN_NAME], '') = ISNULL(n.[COLUMN_NAME], '')
	WHERE	ISNULL(o.[ORDINAL_POSITION], 0) <> ISNULL(n.[ORDINAL_POSITION], 0)

	IF @DiffCount > 0 
		RETURN -2
	ELSE
		RETURN 0
END
GO
PRINT N'Creating [admin].[TableCopy]...';


GO


CREATE PROCEDURE [admin].[TableCopy]
	 @Catalog				NVARCHAR(128)
	,@Schema				NVARCHAR(128)
	,@Table					NVARCHAR(128)
	,@ToSchema				NVARCHAR(128) = NULL	
	,@ToTable				NVARCHAR(128) = NULL
	,@DropToTable			BIT = 0
	,@TruncToTable			BIT = 1
AS
SET NOCOUNT ON
BEGIN
	DECLARE  @QualifiedToTable		NVARCHAR(500)
			,@QualifiedTable		NVARCHAR(500)
			,@SqlColumnList			VARCHAR(MAX)
			,@SqlColumnsSelect		VARCHAR(MAX)
			,@SqlExec				NVARCHAR(MAX)
			,@NL					CHAR(2)
			,@RC					INT

	SET		@NL = CHAR(13) + CHAR(10)
	SET		@ToSchema = ISNULL(@ToSchema, 'copy')
	SET		@ToTable = ISNULL(@ToTable, @Table)
	SELECT	@QualifiedToTable = '[' + @Catalog + '].[' + @ToSchema + '].[' + @ToTable + ']'
	SELECT	@QualifiedTable = '[' + @Catalog + '].[' + @Schema + '].[' + @Table + ']'
	IF OBJECT_ID(@QualifiedTable) IS NOT NULL
	BEGIN
		BEGIN TRY
			BEGIN TRANSACTION;			

			IF OBJECT_ID(@QualifiedToTable) IS NOT NULL AND (@TruncToTable = 1)
			BEGIN 
				EXEC ('TRUNCATE TABLE ' + @QualifiedToTable)
			END
			ELSE IF OBJECT_ID(@QualifiedToTable) IS NOT NULL AND (@DropToTable = 1)
			BEGIN 
				EXEC ('DROP TABLE ' + @QualifiedToTable)
			END

			-- Create Default ToTable if it is missing
			IF OBJECT_ID(@QualifiedToTable) IS NULL
			BEGIN
				SET		@SqlExec = 'SELECT * INTO ' + @QualifiedToTable + ' FROM ' + @QualifiedTable + ' WHERE 1=2'
				EXEC	(@SqlExec)		
			END
				
			DECLARE  @ColumnName		NVARCHAR(128)
					,@FromDataType		NVARCHAR(128)
					,@ToDataType		NVARCHAR(128)
					,@ToMaxLength		VARCHAR(10)
					,@ToPrecision		VARCHAR(10)
					,@ToScale			VARCHAR(10)
				
			-- Get the column info
			DECLARE @tblColumns TABLE ( 
					[ColumnName]		NVARCHAR(128),
					[FromDataType]		NVARCHAR(128),
					[ToDataType]		NVARCHAR(128),
					[ToMaxLength]		VARCHAR(10),
					[ToPrecision]		VARCHAR(10),
					[ToScale]			VARCHAR(10))
				
			SET		@SqlExec = [admin].[GetColumnListStatement](@Catalog, @QualifiedToTable, @QualifiedTable)
			--PRINT	@SqlExec
			INSERT INTO @tblColumns EXEC (@SqlExec)						

			-- Create Cursor for all common columns
			DECLARE crsColumns CURSOR FOR 
			SELECT	 [ColumnName]
					,[FromDataType]
					,[ToDataType]
					,[ToMaxLength]
					,[ToPrecision]
					,[ToScale]
			FROM	@tblColumns	

			OPEN crsColumns
			FETCH NEXT FROM crsColumns INTO @ColumnName, @FromDataType, @ToDataType, @ToMaxLength, @ToPrecision, @ToScale

			SET		@SqlColumnList = ''
			SET		@SqlColumnsSelect = ''
			WHILE @@FETCH_STATUS = 0
			BEGIN
				SET		@SqlColumnList = @SqlColumnList + ',' + @ColumnName	
				SET		@SqlColumnsSelect = @SqlColumnsSelect + ',' + 
						(SELECT CASE @FromDataType
							WHEN @ToDataType THEN @ColumnName
							ELSE		
								'CAST(' + @ColumnName + ' AS ' +
								CASE @ToDataType
									WHEN 'money' THEN 'money(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'decimal' THEN 'decimal(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'numeric' THEN 'numeric(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'smallmoney' THEN 'smallmoney(' + @ToPrecision + ','+ @ToScale+ ')'
									WHEN 'varbinary' THEN 'varbinary(' + @ToMaxLength + ')'
									WHEN 'varchar' THEN 'varchar(' + @ToMaxLength + ')'
									WHEN 'binary' THEN 'binary(' + @ToMaxLength + ')'
									WHEN 'char' THEN 'char(' + @ToMaxLength + ')'
									WHEN 'nvarchar' THEN 'nvarchar(' + @ToMaxLength + ')'
									WHEN 'nchar' THEN 'nchar(' + @ToMaxLength + ')'
									ELSE @ToDataType
								END + ') AS ' + @ColumnName
							END)
				FETCH NEXT FROM crsColumns INTO @ColumnName, @FromDataType, @ToDataType, @ToMaxLength, @ToPrecision, @ToScale
			END
			CLOSE crsColumns
			DEALLOCATE crsColumns

			-- Trim the leading commas
			SET 	@SqlColumnList = RIGHT(@SqlColumnList, LEN(@SqlColumnList) - 1)
			SET		@SqlColumnsSelect = RIGHT(@SqlColumnsSelect, LEN(@SqlColumnsSelect) - 1)
			SET		@SqlExec = 'USE [' + @Catalog + '] SELECT OBJECTPROPERTY(OBJECT_ID(N''' + @QualifiedToTable + '''), N''TableHasIdentity'')'
			
			DECLARE @HasIdentity INT
			DECLARE @tblHasIdentity TABLE ([HasIdentity]	INT)
							
			INSERT INTO @tblHasIdentity
			EXEC	(@SqlExec)
					
			SELECT	@HasIdentity = ISNULL([HasIdentity], 0)
			FROM	@tblHasIdentity
					
			-- Build the copy sql
			SET		@SqlExec = 'INSERT INTO ' + @QualifiedToTable + '(' + @SqlColumnList + ') ' +  @NL 
					+ 'SELECT ' + @SqlColumnsSelect + @NL
					+ 'FROM ' + @QualifiedTable

			-- If identity append the SET IDENTITY_INSERT commands
			IF @HasIdentity = 1
					SET		@SqlExec = 'SET IDENTITY_INSERT ' + @QualifiedToTable + ' ON ;' +  @NL 
							+ ' ' +  @SqlExec + '; ' +  @NL + 'SET IDENTITY_INSERT ' + @QualifiedToTable + ' OFF'

			EXEC	(@SqlExec)

			COMMIT TRANSACTION;			

		END TRY

		BEGIN CATCH
			SELECT	ERROR_NUMBER()	AS [ErrorNumber],
					ERROR_MESSAGE() AS [ErrorMessage];

			-- Test if the transaction is uncommittable.
			IF (XACT_STATE()) = -1
			BEGIN
				PRINT	N'The transaction is in an uncommittable state. ' +
						'Rolling back transaction.'
				ROLLBACK TRANSACTION;
			END;

			-- Test if the transaction is active and valid.
			IF (XACT_STATE()) = 1
			BEGIN
				PRINT	N'The transaction is committable. ' +
						'Committing transaction.'
				COMMIT TRANSACTION;   
			END;
			RETURN	ERROR_NUMBER();
		END CATCH;
	END
	RETURN 0
END
GO
PRINT N'Creating [admin].[TableDeploy]...';


GO


CREATE PROCEDURE [admin].[TableDeploy]
	 @Catalog				NVARCHAR(128)
	,@Schema				NVARCHAR(128)
	,@Table					NVARCHAR(128)
	,@ToSchema				NVARCHAR(128) = NULL	
	,@ToTable				NVARCHAR(128) = NULL
	,@BackupSchema			NVARCHAR(128) = NULL
AS

SET NOCOUNT ON
DECLARE  @QualifiedToTable	NVARCHAR(512)
		,@QualifiedTable	NVARCHAR(512)
		,@BackupTable		NVARCHAR(512)
		,@SqlExec			NVARCHAR(MAX)
		,@NL				CHAR(2)			= CHAR(13) + CHAR(10)
		,@RC				INT

SET		@ToSchema = ISNULL(@ToSchema, 'copy')
SET		@ToTable = ISNULL(@ToTable, @Table)
SET		@QualifiedToTable = '[' + @Catalog + '].[' + @ToSchema + '].[' + @ToTable + ']'
SET		@QualifiedTable = '[' + @Catalog + '].[' + @Schema + '].[' + @Table + ']'
SET		@BackupTable = '[' + @Catalog + '].[backup].[' + @Table + ']'

SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''backup'') EXEC (''CREATE SCHEMA [backup] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)
SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''copy'') EXEC (''CREATE SCHEMA [copy] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)
SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
		+ 'IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = N''' + @Schema + ''') EXEC (''CREATE SCHEMA [' + @Schema + '] AUTHORIZATION [dbo]'')'
EXEC	(@SqlExec)

DECLARE @tblConstraints	TABLE(
		[ParentTable]			[nvarchar](512),
		[ForeignKeyConstraint]	[nvarchar](512),
		[ReferenceTable]		[nvarchar](512),
		[ForeignKeyColumn]		[nvarchar](512),
		[ReferenceColumn]		[nvarchar](512),
		[ConstraintCascade]		[nvarchar](128),
		[DropPattern]			[nvarchar](256),
		[CreatePattern]			[nvarchar](256))

IF OBJECT_ID(@BackupTable) IS NOT NULL
BEGIN 
	EXEC ('DROP TABLE ' + @BackupTable)
END

IF OBJECT_ID(@QualifiedTable) IS NULL
BEGIN
	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
			+ 'ALTER SCHEMA [' + @Schema + '] TRANSFER [' + @ToSchema + '].[' + @ToTable + ']'
	EXEC (@SqlExec)
END
ELSE
BEGIN
	EXEC @RC = [admin].[TableCompare] @Catalog, @Schema, @Table, @ToSchema, @ToTable

	IF ISNULL(@RC, -1) = -1		-- Table changes detected
	BEGIN
		EXEC @RC = [admin].[TableCopy] @Catalog, @Schema, @Table, @ToSchema, @ToTable

		SET	@SqlExec = [admin].[GetForeignKeyStatement](@Catalog, @QualifiedTable)
		INSERT INTO @tblConstraints EXEC (@SqlExec)

		BEGIN TRY
			BEGIN TRANSACTION;	
					
			IF OBJECT_ID(@QualifiedTable) IS NOT NULL
			BEGIN
				DECLARE crsDropConstraints CURSOR FOR
				SELECT	'USE [' + @Catalog + ']' + @NL + REPLACE(REPLACE([DropPattern], '<<ParentTable>>', [ParentTable]), '<<ForeignKeyConstraint>>', [ForeignKeyConstraint])
				FROM	@tblConstraints

				OPEN crsDropConstraints
				FETCH NEXT FROM crsDropConstraints INTO @SqlExec
				WHILE @@FETCH_STATUS = 0
				BEGIN
					EXEC (@SqlExec)
					FETCH NEXT FROM crsDropConstraints INTO @SqlExec
				END
				CLOSE crsDropConstraints
				DEALLOCATE crsDropConstraints
				
				-- ALTER SCHEMA [backup]				
				SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
						+ 'ALTER SCHEMA [backup] TRANSFER [' + @Schema + '].[' + @Table + ']'
				EXEC (@SqlExec)
			END		
														
			-- ALTER SCHEMA @Schema
			SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
					+ 'ALTER SCHEMA [' + @Schema + '] TRANSFER [' + @ToSchema + '].[' + @ToTable + ']'
			EXEC (@SqlExec)
			
			DECLARE crsAddConstraints CURSOR FOR
			SELECT	'USE [' + @Catalog + ']' + @NL +
					REPLACE(
						REPLACE(
							REPLACE(
								REPLACE(
									REPLACE(
										REPLACE([CreatePattern], '<<ParentTable>>', [ParentTable])
									, '<<ForeignKeyConstraint>>', [ForeignKeyConstraint])
								,'<<ForeignKeyColumn>>', [ForeignKeyColumn])
							,'<<ReferenceTable>>', [ReferenceTable])
						,'<<ReferenceColumn>>', [ReferenceColumn])
					,'<<ConstraintCascade>>', [ConstraintCascade])
			FROM	@tblConstraints

			OPEN crsAddConstraints
			FETCH NEXT FROM crsAddConstraints INTO @SqlExec
			WHILE @@FETCH_STATUS = 0
			BEGIN
				EXEC (@SqlExec)
				FETCH NEXT FROM crsAddConstraints INTO @SqlExec
			END
			CLOSE crsAddConstraints
			DEALLOCATE crsAddConstraints

			COMMIT TRANSACTION;

			IF OBJECT_ID(@BackupTable) IS NOT NULL
			BEGIN 
				SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
						+ 'DROP TABLE [backup].[' + @Table + ']'
				EXEC (@SqlExec)			
			END
		END TRY
				
		BEGIN CATCH
			SELECT	ERROR_NUMBER()	AS [ErrorNumber],
					ERROR_MESSAGE() AS [ErrorMessage];

			-- Test if the transaction is uncommittable.
			IF (XACT_STATE()) = -1
			BEGIN
				PRINT	N'The transaction is in an uncommittable state. ' +
						'Rolling back transaction.'
				ROLLBACK TRANSACTION;
			END;

			-- Test if the transaction is active and valid.
			IF (XACT_STATE()) = 1
			BEGIN
				PRINT	N'The transaction is committable. ' +
						'Committing transaction.'
				COMMIT TRANSACTION;   
			END;
			RETURN	ERROR_NUMBER();
		END CATCH;

		RETURN 0
	END
--	ELSE IF ISNULL(@RC, -1) = -2		-- PRIMARY KEY CHANGES DETECTED
--	BEGIN
--
--	END
	ELSE
	BEGIN
		IF OBJECT_ID(@QualifiedToTable) IS NOT NULL
		BEGIN 
			SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL 
					+ 'DROP TABLE ' + @QualifiedToTable
			EXEC (@SqlExec)			
		END
	END
END
GO
PRINT N'Creating [admin].[TableRenameConstraints]...';


GO


CREATE PROCEDURE [admin].[TableRenameConstraints]
	 @Catalog				NVARCHAR(128)
	,@Schema				NVARCHAR(128)
	,@Table					NVARCHAR(128)
AS
SET NOCOUNT ON
BEGIN
	DECLARE  @QualifiedTable		NVARCHAR(500)
			,@SqlExec				NVARCHAR(MAX)
			,@NL					CHAR(2)
			,@RC					INT

	SET		@NL = CHAR(13) + CHAR(10);
	SELECT	@QualifiedTable = '[' + @Catalog + '].[' + @Schema + '].[' + @Table + ']';

	DECLARE @tblRename TABLE([SqlExec]	NVARCHAR(MAX));

	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
			+ 'SELECT	''ALTER TABLE '' + ''' + @QualifiedTable + ''' + '' DROP CONSTRAINT ['' + dc.[name] + '']; ''
					+ ''ALTER TABLE '' + ''' + @QualifiedTable + ''' + '' ADD CONSTRAINT [DF_'' + SCHEMA_NAME(dc.[schema_id]) + OBJECT_NAME(dc.[parent_object_id]) 
					+ ''_'' + COL_NAME(dc.[parent_object_id], dc.[parent_column_id]) + ''] DEFAULT '' + dc.[definition] + '' FOR ['' 
					+ COL_NAME(dc.[parent_object_id], dc.[parent_column_id]) + ''];''
			FROM	[sys].[default_constraints] dc
			WHERE	dc.[parent_object_id] = OBJECT_ID(''' + @QualifiedTable + ''');';
	INSERT	@tblRename EXEC (@SqlExec);
	
	SET		@SqlExec = 'USE [' + @Catalog + ']' + @NL
			+ 'SELECT	''EXEC sp_rename N''''' + @QualifiedTable + '.['' + so.[name] + '']'''', N'''
						+ '''PK'' + CASE INDEXPROPERTY(so.[parent_object_id], so.[name], ''IsClustered'') WHEN 1 THEN ''C_'' ELSE ''N_'' END 
						+ SCHEMA_NAME(so.[schema_id]) + OBJECT_NAME(so.[parent_object_id]) + '''''', N''''INDEX''''''
				FROM	[sys].[objects] so
				WHERE	OBJECTPROPERTY(so.[object_id] ,''IsPrimaryKey'')  = 1
				AND		so.[parent_object_id] = OBJECT_ID(''' + @QualifiedTable + ''');';
	--PRINT	@SqlExec;
	INSERT	@tblRename EXEC (@SqlExec);
	
	DECLARE crsRenameDefaults CURSOR FOR
	SELECT	'USE [' + @Catalog + ']' + @NL + [SqlExec]
	FROM	@tblRename;

	OPEN crsRenameDefaults;
	FETCH NEXT FROM crsRenameDefaults INTO @SqlExec;
	WHILE @@FETCH_STATUS = 0
	BEGIN
		EXEC (@SqlExec);
		FETCH NEXT FROM crsRenameDefaults INTO @SqlExec;
	END
	CLOSE crsRenameDefaults;
	DEALLOCATE crsRenameDefaults;
	
END
GO
PRINT N'Creating [ssis].[LogAuditRow]...';


GO

CREATE PROCEDURE [ssis].[LogAuditRow]
    @ExecutionID			[int],
	@ExecutionInstanceGUID	[nchar](36), 
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @AuditType				[varchar](20),
    @RowCount				[int],
    @DistinctRowCount		[int] = NULL,
    @AuditRowSchema			[xml],
	@AuditRowData			[AuditRowDataType] READONLY
AS
SET NOCOUNT ON
BEGIN TRY


	DECLARE	 @AuditRowID		BIGINT
	
    INSERT INTO [ssis].[AuditRow]
        ([ExecutionID]
		,[ExecutionInstanceGUID]
        ,[ComponentName]
        ,[ObjectName]
        ,[AuditType]
        ,[RowCount]
        ,[DistinctRowCount]
        ,[AuditRowSchema])
    VALUES
        (@ExecutionID
		,@ExecutionInstanceGUID
        ,@ComponentName
        ,@ObjectName
        ,@AuditType
        ,@RowCount
        ,@DistinctRowCount
        ,@AuditRowSchema);

	SELECT @AuditRowID = SCOPE_IDENTITY();

	INSERT INTO [ssis].[AuditRowData]
			([AuditRowID]
			,[RowID]
			,[ColumnName]
			,[ColumnValue])
     SELECT	 @AuditRowID	
			,[RowID]
			,[ColumnName]
			,[ColumnValue]
	FROM	@AuditRowData

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Creating [ssis].[LogExecution]...';


GO
CREATE PROCEDURE [ssis].[LogExecution](
	@ExecutionGUID			[nvarchar](40),
	@SourceGUID				[nvarchar](40),
	@PackageName			[varchar](500),
	@ParentSourceGUID		[nvarchar](40),
	@ParentExecutionID		[int],
	@ServerExecutionID		[bigint],
	@ExecutionID			[int]         = NULL OUTPUT
) 
AS 
CREATE TABLE #Object ([ObjectID] [int]);


SELECT  @ExecutionID = MAX([ExecutionID])
FROM    [ssis].[Execution]
WHERE   [SourceGUID] = REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
AND		[ExecutionGUID] = REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
AND		[ParentExecutionID] = ISNULL(@ParentExecutionID, -1);

IF @ExecutionID IS NULL
BEGIN
	INSERT INTO [ssis].[Execution]
			([ParentExecutionID]
			,[ExecutionGUID]
			,[SourceGUID]
			,[PackageName]
			,[ParentSourceGUID]
			,[ServerExecutionID])
	VALUES	(ISNULL(@ParentExecutionID, -1)
			,REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
			,REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
			,ISNULL(@PackageName, 'Not Sepcified')
			,ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '')
			,@ServerExecutionID);

	SELECT  @ExecutionID = SCOPE_IDENTITY();
END

IF ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '') <> ''
BEGIN
	UPDATE	[ssis].[Execution]
	SET		[ParentSourceGUID] = REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', '')
	WHERE	[ServerExecutionID] = @ServerExecutionID
END
GO
PRINT N'Creating [ssis].[LogRowCount]...';


GO
CREATE PROCEDURE [ssis].[LogRowCount](
    @ExecutionID			[int],
	@ExecutionInstanceGUID	[nchar](36), 
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @CountType				[varchar](20),
    @RowCount				[int],
	@ColumnSum				[money],
	@ColumnName				[varchar](200)
) 
AS
BEGIN TRY
	
    INSERT INTO [ssis].[RowCount]
        ([ExecutionID]
		,[ExecutionInstanceGUID]
        ,[ComponentName]
        ,[ObjectName]
        ,[CountType]
        ,[RowCount]
		,[ColumnSum]
		,[ColumnName])
    VALUES
        (@ExecutionID
		,@ExecutionInstanceGUID
        ,@ComponentName
        ,@ObjectName
        ,@CountType
        ,@RowCount
		,@ColumnSum
		,@ColumnName);

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Update complete.';


GO
