﻿/*
Deployment script for Bimp

This code was generated by a tool.
Changes to this file may cause incorrect behavior and will be lost if
the code is regenerated.
*/

GO
SET ANSI_NULLS, ANSI_PADDING, ANSI_WARNINGS, ARITHABORT, CONCAT_NULL_YIELDS_NULL, QUOTED_IDENTIFIER ON;

SET NUMERIC_ROUNDABORT OFF;


GO
:setvar DatabaseName "Bimp"
:setvar DefaultFilePrefix "Bimp"
:setvar DefaultDataPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"
:setvar DefaultLogPath "C:\MSSQL\MSSQL10_50.SQL2008R2\MSSQL\DATA\"

GO
:on error exit
GO
/*
Detect SQLCMD mode and disable script execution if SQLCMD mode is not supported.
To re-enable the script after enabling SQLCMD mode, execute the following:
SET NOEXEC OFF; 
*/
:setvar __IsSqlCmdEnabled "True"
GO
IF N'$(__IsSqlCmdEnabled)' NOT LIKE N'True'
    BEGIN
        PRINT N'SQLCMD mode must be enabled to successfully execute this script.';
        SET NOEXEC ON;
    END


GO
USE [$(DatabaseName)];


GO
/*
The column [ssis].[AuditRow].[AuditRowDate] is being dropped, data loss could occur.

The column [ssis].[AuditRow].[ExecutionInstanceGUID] is being dropped, data loss could occur.
*/

IF EXISTS (select top 1 1 from [ssis].[AuditRow])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
/*
The column [ssis].[RowCount].[ExecutionInstanceGUID] is being dropped, data loss could occur.

The column [ssis].[RowCount].[RowCountDate] is being dropped, data loss could occur.
*/

IF EXISTS (select top 1 1 from [ssis].[RowCount])
    RAISERROR (N'Rows were detected. The schema update is terminating because data loss might occur.', 16, 127) WITH NOWAIT

GO
PRINT N'Dropping DF__AuditRow__AuditR__36B12243...';


GO
ALTER TABLE [ssis].[AuditRow] DROP CONSTRAINT [DF__AuditRow__AuditR__36B12243];


GO
PRINT N'Dropping DF__RowCount__RowCou__398D8EEE...';


GO
ALTER TABLE [ssis].[RowCount] DROP CONSTRAINT [DF__RowCount__RowCou__398D8EEE];


GO
PRINT N'Dropping [rpt]...';


GO
DROP SCHEMA [rpt];


GO
PRINT N'Dropping [udf]...';


GO
DROP SCHEMA [udf];


GO
PRINT N'Altering [ssis].[AuditRow]...';


GO
ALTER TABLE [ssis].[AuditRow] DROP COLUMN [AuditRowDate], COLUMN [ExecutionInstanceGUID];


GO
PRINT N'Altering [ssis].[RowCount]...';


GO
ALTER TABLE [ssis].[RowCount] DROP COLUMN [ExecutionInstanceGUID], COLUMN [RowCountDate];


GO
PRINT N'Altering [ssis].[LogAuditRow]...';


GO

ALTER PROCEDURE [ssis].[LogAuditRow]
    @ExecutionID			[int],
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @AuditType				[varchar](20),
    @RowCount				[int],
    @DistinctRowCount		[int] = NULL,
    @AuditRowSchema			[xml],
	@AuditRowData			[AuditRowDataType] READONLY
AS
SET NOCOUNT ON
BEGIN TRY


	DECLARE	 @AuditRowID		BIGINT
	
    INSERT INTO [ssis].[AuditRow]
        ([ExecutionID]
        ,[ComponentName]
        ,[ObjectName]
        ,[AuditType]
        ,[RowCount]
        ,[DistinctRowCount]
        ,[AuditRowSchema])
    VALUES
        (@ExecutionID
        ,@ComponentName
        ,@ObjectName
        ,@AuditType
        ,@RowCount
        ,@DistinctRowCount
        ,@AuditRowSchema);

	SELECT @AuditRowID = SCOPE_IDENTITY();

	INSERT INTO [ssis].[AuditRowData]
			([AuditRowID]
			,[RowID]
			,[ColumnName]
			,[ColumnValue])
     SELECT	 @AuditRowID	
			,[RowID]
			,[ColumnName]
			,[ColumnValue]
	FROM	@AuditRowData

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Altering [ssis].[LogRowCount]...';


GO
ALTER PROCEDURE [ssis].[LogRowCount](
    @ExecutionID			[int],
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @CountType				[varchar](20),
    @RowCount				[int],
	@ColumnSum				[money],
	@ColumnName				[varchar](200)
) 
AS
BEGIN TRY
	
    INSERT INTO [ssis].[RowCount]
        ([ExecutionID]
        ,[ComponentName]
        ,[ObjectName]
        ,[CountType]
        ,[RowCount]
		,[ColumnSum]
		,[ColumnName])
    VALUES
        (@ExecutionID
        ,@ComponentName
        ,@ObjectName
        ,@CountType
        ,@RowCount
		,@ColumnSum
		,@ColumnName);

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;
GO
PRINT N'Altering [ssis].[LogExecution]...';


GO
ALTER PROCEDURE [ssis].[LogExecution](
	@ExecutionGUID			[nvarchar](40),
	@SourceGUID				[nvarchar](40),
	@PackageName			[varchar](500),
	@ParentSourceGUID		[nvarchar](40),
	@ParentExecutionID		[int],
	@ServerExecutionID		[bigint],
	@ExecutionID			[int]         = NULL OUTPUT
) 
AS 

SELECT  @ExecutionID = MAX([ExecutionID])
FROM    [ssis].[Execution]
WHERE   [SourceGUID] = REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
AND		[ExecutionGUID] = REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
AND		[ParentExecutionID] = ISNULL(@ParentExecutionID, -1);

IF @ExecutionID IS NULL
BEGIN
	INSERT INTO [ssis].[Execution]
			([ParentExecutionID]
			,[ExecutionGUID]
			,[SourceGUID]
			,[PackageName]
			,[ParentSourceGUID]
			,[ServerExecutionID])
	VALUES	(ISNULL(@ParentExecutionID, -1)
			,REPLACE(REPLACE(@ExecutionGUID, '{', ''), '}', '')
			,REPLACE(REPLACE(@SourceGUID, '{', ''), '}', '')
			,ISNULL(@PackageName, 'Not Sepcified')
			,ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '')
			,@ServerExecutionID);

	SELECT  @ExecutionID = SCOPE_IDENTITY();
END

IF ISNULL(REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', ''), '') <> ''
BEGIN
	UPDATE	[ssis].[Execution]
	SET		[ParentSourceGUID] = REPLACE(REPLACE(@ParentSourceGUID, '{', ''), '}', '')
	WHERE	[ExecutionID] = @ExecutionID
END
GO
PRINT N'Update complete.';


GO
