﻿
CREATE PROCEDURE [ssis].[LogAuditRow]
    @ExecutionID			[int],
    @ComponentName			[nvarchar](200),
    @ObjectName				[nvarchar](200),
    @AuditType				[varchar](20),
    @RowCount				[int],
    @DistinctRowCount		[int] = NULL,
    @AuditRowSchema			[xml],
	@AuditRowData			[AuditRowDataType] READONLY
AS
SET NOCOUNT ON
BEGIN TRY


	DECLARE	 @AuditRowID		BIGINT
	
    INSERT INTO [ssis].[AuditRow]
        ([ExecutionID]
        ,[ComponentName]
        ,[ObjectName]
        ,[AuditType]
        ,[RowCount]
        ,[DistinctRowCount]
        ,[AuditRowSchema])
    VALUES
        (@ExecutionID
        ,@ComponentName
        ,@ObjectName
        ,@AuditType
        ,@RowCount
        ,@DistinctRowCount
        ,@AuditRowSchema);

	SELECT @AuditRowID = SCOPE_IDENTITY();

	INSERT INTO [ssis].[AuditRowData]
			([AuditRowID]
			,[RowID]
			,[ColumnName]
			,[ColumnValue])
     SELECT	 @AuditRowID	
			,[RowID]
			,[ColumnName]
			,[ColumnValue]
	FROM	@AuditRowData

	RETURN(0);
END TRY

BEGIN CATCH
    RETURN ERROR_NUMBER();
END CATCH;